/*** This Programs/Libraries are (C)opyright by S. Krahmer.
 *** You may use it under the terms of the GPL. You should have
 *** already received the file COPYING that shows you your rights. If not
 *** you can get it at http://www.cs.uni-potsdam.de/homepages/students/linuxer
 *** the logit-package. You will also find some other nice utillities there.
 ***  
 *** THERE IS ABSOLUTELY NO WARRANTY. SO YOU USE IT AT YOUR OWN RISK.
 *** IT WAS WRITTEN IN THE HOPE THAT IT WILL BE USEFULL. I'M NOT RESPONSIBLE
 *** FOR ANY DAMAGE YOU MAYBE GET DUE TO USING MY PROGRAMS.
 ***/
#define __KERNEL__
#define MODULE

#include <linux/version.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/sched.h>

#include "lncf.h"

#ifndef KERNEL_VERSION
#error "What do you do? This is kernel 2.2 stuff only!"
#endif

extern void *sys_call_table[];

/* copied from kernel-sources
 */
inline void put_unused_fd(unsigned int fd)
{
	FD_CLR(fd, &current->files->open_fds);
}

/* our new syscall
 */
int hijack_service(int service, int pid, int fd, int flag)
{	
	int retval = 0;
	
	/* if not the superuser */
	if (current->euid || current->uid)
		return -EPERM;
		
	switch (service) {
	
	/* request for open
	 */
	case HJS_OPEN: {
		int i = 0;
		struct task_struct *task = current;
		
		/* get actual task we hijack 
		 */
		while (task->pid != pid && i++ <= NR_TASKS)
			task = task->next_task;
			
		/* no such pid found
		 */
		if (i > NR_TASKS)
			return -1;
			
		i = get_unused_fd();
		
		/* and stole other task the fd
		 */
		current->files->fd[i] = task->files->fd[fd];
		
		if (flag == HJS_LOCK)
			task->files->fd[fd] = NULL;
		retval = i;
		MOD_INC_USE_COUNT;
		break;
	}
        
        /* in this case, flag is the fd that should be restored, or -1 if not
         */
	case HJS_CLOSE: 
		if (fd < 0 || fd > 255)
			return -1;
                        
		if (flag > -1)	{
                   	int i = 0;
                        struct task_struct *task = current;
		
                        while (task->pid != pid && i++ <= NR_TASKS)
                           	task = task->next_task;
			
                        if (i > NR_TASKS)
                           	return -1;
			task->files->fd[flag] = current->files->fd[fd];
                }
		put_unused_fd(fd);
		current->files->fd[fd] = NULL;
		retval = 0;
		MOD_DEC_USE_COUNT;
		break;
	default:
		break;
	}
	return retval;
}

int init_module()
{
	EXPORT_NO_SYMBOLS;
	
	/* Well, usecount should be 1 always, b/c i see kernel-panics
	 * if module is unloaded and one tries to access syscall 241.
	 * This doesn't occur the first time you call hijack_service, but 
	 * after calling/deloading/calling
	 */
	MOD_INC_USE_COUNT;		
	sys_call_table[HIJACK_SERVICE] = hijack_service;
        return 0;
}

int cleanup_module()
{
	sys_call_table[HIJACK_SERVICE] = NULL;
        return 0;
}
